diff --git a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
index e8cf4ceeb..f537cb748 100644
--- a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
+++ b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
@@ -386,12 +386,12 @@ public class PacketHandlerServer extends PacketHandler
                     j1 = i1;
                 }
                 if (this.hasMoved && this.playerEntity.distanceToSqr((double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D) < 64D && (j1 > this.mcServer.spawnProtectionRange || ignoreSpawnProtection)) {
-                    this.playerEntity.playerController.useOrPlaceItemStackOnTile(this.playerEntity, worldserver, itemstack, x, y, z, direction.getSide(), xPlaced, yPlaced);
+                    this.playerEntity.playerController.useOrPlaceItemStackOnTile(this.playerEntity, worldserver, itemstack, x, y, z, direction.side(), xPlaced, yPlaced);
                 }
                 this.playerEntity.playerNetServerHandler.sendPacket(new PacketBlockUpdate(x, y, z, worldserver));
-                x += direction.getOffsetX();
-                y += direction.getOffsetY();
-                z += direction.getOffsetZ();
+                x += direction.offsetX();
+                y += direction.offsetY();
+                z += direction.offsetZ();
                 this.playerEntity.playerNetServerHandler.sendPacket(new PacketBlockUpdate(x, y, z, worldserver));
                 break;
             }
@@ -416,12 +416,12 @@ public class PacketHandlerServer extends PacketHandler
                     j1 = i1;
                 }
                 if (this.hasMoved && this.playerEntity.distanceToSqr((double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D) < 64D && (j1 > this.mcServer.spawnProtectionRange || ignoreSpawnProtection)) {
-                    this.playerEntity.playerController.placeItemStackOnTile(this.playerEntity, worldserver, itemstack, x, y, z, direction.getSide(), xPlaced, yPlaced);
+                    this.playerEntity.playerController.placeItemStackOnTile(this.playerEntity, worldserver, itemstack, x, y, z, direction.side(), xPlaced, yPlaced);
                 }
                 this.playerEntity.playerNetServerHandler.sendPacket(new PacketBlockUpdate(x, y, z, worldserver));
-                x += direction.getOffsetX();
-                y += direction.getOffsetY();
-                z += direction.getOffsetZ();
+                x += direction.offsetX();
+                y += direction.offsetY();
+                z += direction.offsetZ();
                 this.playerEntity.playerNetServerHandler.sendPacket(new PacketBlockUpdate(x, y, z, worldserver));
                 break;
             }
@@ -738,9 +738,9 @@ public class PacketHandlerServer extends PacketHandler
     public void handleCustomPayload(@NotNull PacketCustomPayload packetCustomPayload) {
         if (PacketCustomPayload.CHANNEL_ROTATION_LOCK.equals(packetCustomPayload.channel)) {
             if (packetCustomPayload.data.length == 4) {
-                this.playerEntity.rotationLock = Direction.getDirectionById(packetCustomPayload.data[0]);
-                this.playerEntity.rotationLockHorizontal = Direction.getDirectionById(packetCustomPayload.data[1]);
-                this.playerEntity.rotationLockVertical = Direction.getDirectionById(packetCustomPayload.data[2]);
+                this.playerEntity.rotationLock = Direction.fromId(packetCustomPayload.data[0]);
+                this.playerEntity.rotationLockHorizontal = Direction.fromId(packetCustomPayload.data[1]);
+                this.playerEntity.rotationLockVertical = Direction.fromId(packetCustomPayload.data[2]);
                 this.playerEntity.placementModeOverride = PlacementMode.get(packetCustomPayload.data[3]);
             }
         } else if (PacketCustomPayload.CHANNEL_FLAG.equals(packetCustomPayload.channel)) {
diff --git a/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java b/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
index 15b788c19..82a1a4cab 100644
--- a/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
+++ b/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
@@ -7,6 +7,7 @@ import net.minecraft.core.item.ItemBucket;
 import net.minecraft.datagen.recipeBuilders.RecipeBuilder;
 import net.minecraft.datagen.recipeBuilders.RecipeBuilderShaped;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.piston.PistonCommon;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.data.registry.recipe.RecipeSymbol;
 import net.minecraft.core.item.ItemStack;
@@ -1226,6 +1227,14 @@ class WorkbenchGenerator {
             .addInput('R', Items.DUST_REDSTONE)
             .create("piston", new ItemStack(Blocks.PISTON_BASE));
 
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "XXX",
+                " B ")
+            .addInput('X', "minecraft:planks")
+            .addInput('B', PistonCommon.baseItem(PistonCommon.TYPE_NORMAL, false, true))
+            .create("piston_reattach", new ItemStack(Blocks.PISTON_BASE));
+
         RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
                 "S",
@@ -1236,14 +1245,32 @@ class WorkbenchGenerator {
 
         RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
+                " S ",
                 "XXX",
-                "#I#",
-                "#R#")
+                " B ")
+            .addInput('S', Items.SLIMEBALL)
+            .addInput('X', "minecraft:planks")
+            .addInput('B', PistonCommon.baseItem(PistonCommon.TYPE_STICKY, false, true))
+            .create("sticky_piston_reattach", Blocks.PISTON_BASE_STICKY.getDefaultStack());
+        
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+        .setShape(
+            "XXX",
+            "#I#",
+            "#R#")
             .addInput('X', Items.INGOT_STEEL_CRUDE)
             .addInput('#', "minecraft:stones")
             .addInput('I', Items.INGOT_STEEL)
             .addInput('R', Items.DUST_REDSTONE)
             .create("steel_piston", Blocks.PISTON_BASE_STEEL.getDefaultStack());
+            
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "XXX",
+                " B ")
+            .addInput('X', Items.INGOT_STEEL_CRUDE)
+            .addInput('B', PistonCommon.baseItem(PistonCommon.TYPE_STEEL, false, true))
+            .create("steel_piston_reattach", Blocks.PISTON_BASE_STEEL.getDefaultStack());
 
         RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
@@ -1295,6 +1322,15 @@ class WorkbenchGenerator {
             .addInput('I', "minecraft:stones")
             .create("redstone_repeater", new ItemStack(Items.REPEATER, 1));
 
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "#X#",
+                "III")
+            .addInput('#', Blocks.TORCH_REDSTONE_ACTIVE)
+            .addInput('X', Items.QUARTZ)
+            .addInput('I', "minecraft:stones")
+            .create("redstone_timer", new ItemStack(Items.TIMER, 1));
+
         RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
                 "X",
